<?php
namespace Faturamento\Repositories;

class Propostaserv extends \Doctrine\ORM\EntityRepository
{
    public function servicosProposta($proposta, $versao){
        $sql = "SELECT PS.NRPROPOSFAS, PS.NRVERPROPFAS, PS.CDTIPOSERV, NVL(PS.VRHORAPROP,0) AS VRHORAPROP, TP.NMTIPOSERV,
                       PS.NROPCPROPSERV, PS.DSLOCALPROP, PS.IDTIPOCOBRPROP, PS.VRPEACHEPROP, PS.QTSERVPROP, PS.VREXCEDPROP,
                       DECODE(PS.VRHORAPROP,0,0,(NVL(100 - (PS.VRDEHORAPROP / PS.VRHORAPROP) * 100,0))) AS VRPEHORAPROP,
                       NVL(NVL(VRDEHORAPROP, VRHORAPROP),0) AS VRDEHORAPROP, PS.NRSERVPROP, PF.NRMESREAJPROP,
                       TRUNC(PF.VRPACOTESERV, 2) AS VRPACOTESERV, ' ' AS VERIFICA_DESCRICAO
                  FROM PROPOSTASERV PS, TIPOSERV TP, PROPOSTAFAS PF
                 WHERE (PS.NRPROPOSFAS = :P_NRPROPOSFAS)
                   AND (PS.NRVERPROPFAS = :P_NRVERPROPFAS)
                   AND (PS.CDTIPOSERV  = TP.CDTIPOSERV )
                   AND (PS.NRPROPOSFAS = PF.NRPROPOSFAS)
                   AND (PS.NRVERPROPFAS = PF.NRVERPROPFAS)
                 ORDER BY PS.CDTIPOSERV";

        $params = array(
            "P_NRPROPOSFAS"   => $proposta[''],
            "P_NRVERPROPFAS"   => $versao[''],
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function consultaProxNumeroServico($nrorg, $nrproposfas, $cdtiposerv)
    {
        $sql = "
            SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(PS.NRSERVPROP)), 0)+1, '009')) AS NRSERVPROP
              FROM PROPOSTASERV PS
             WHERE PS.NRORG = :NRORG
               AND PS.NRPROPOSFAS = :NRPROPOSFAS
               AND PS.CDTIPOSERV = :CDTIPOSERV";
        
        $params = array(
            'NRORG'       => $nrorg, 
            'NRPROPOSFAS' => $nrproposfas, 
            'CDTIPOSERV'  => $cdtiposerv        
        );
        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function consultaServObrig($nrproposfas, $nrverpropfas, $cdoperador, $cdcliepros, $nrorg)
    {
        $sql = "SELECT  :NRORG AS NRORG, :NRPROPOSFAS AS NRPROPOSFAS, :NRVERPROPFAS AS NRVERPROPFAS,TPS.CDTIPOSERV AS CDTIPOSERV,
                        DECODE(PSV.NRSERVPROP, NULL, 'N', 'S') AS IDMARCADO, NVL(PSV.DSLOCALPROP, '') AS DSLOCALPROP,
                        PSV.NRSERVPROP AS NRSERVPROP, NULL AS NRSERVCONT, PSV.VRHORAPROP, TPS.NMTIPOSERV,
                        PSV.IDTIPOCOBRPROP, NVL(PSV.QTSERVPROP, NVL(TPS.QTHORAFLP, 0)) QTSERVPROP,
                        DECODE((CASE 
                                  ENP.CDPAIS WHEN '0055' 
                                  THEN TPS.VRPADRAOSERVNAC 
                                  ELSE TPS.VRPADRAOSERVINT END), 0, PSV.VRHORAPROP, 
                                                                       ROUND(CASE 
                                                                                ENP.CDPAIS WHEN '0055' 
                                                                                THEN TPS.VRPADRAOSERVNAC 
                                                                                ELSE TPS.VRPADRAOSERVINT END, 2)) AS VRHORACONT,
                        CASE WHEN (DECODE((CASE 
                                  ENP.CDPAIS WHEN '0055' 
                                  THEN TPS.VRPADRAOSERVNAC 
                                  ELSE TPS.VRPADRAOSERVINT END), 0, PSV.VRHORAPROP, 
                                                                       ROUND(CASE 
                                                                                ENP.CDPAIS WHEN '0055' 
                                                                                THEN TPS.VRPADRAOSERVNAC 
                                                                                ELSE TPS.VRPADRAOSERVINT END, 2))) = PSV.VRHORAPROP 
                             THEN 0
                             ELSE ROUND(100 - (PSV.VRHORAPROP * 100) / (DECODE(PSV.NRSERVPROP, NULL, PSV.VRHORAPROP, 
                                                                            CASE 
                                                                                ENP.CDPAIS WHEN '0055' 
                                                                                THEN TPS.VRPADRAOSERVNAC 
                                                                                ELSE TPS.VRPADRAOSERVINT END)), 2) END AS VRDEHORAPROP, 
                        NVL(PSV.ORIGEM, 'PADRAO') AS ORIGEM,
                        CASE WHEN VRDEHORAPROP = 100 THEN 0 ELSE (QTSERVPROP * PSV.VRHORAPROP) END AS VRTOTALSERV,
                        NVL(PSV.VRPEDESOPERSERV, 0) AS VRPEDESOPERSERV, TPS.IDPROPSERVWEB, TPS.IDSERVOBRIGPROS 
                    FROM TIPOSERV TPS, ENDEPROSPECT ENP,
                        (SELECT PS.CDTIPOSERV, PS.NRSERVPROP, TS.NMTIPOSERV, PS.DSLOCALPROP, PS.IDTIPOCOBRPROP,
                                PS.VRPEACHEPROP, PS.QTSERVPROP, PS.VRHORAPROP, PS.VRDEHORAPROP,
                                PS.NRPROPOSFAS, PS.NRVERPROPFAS, NVL(OP.VRPEDESOPERSERV, 0) AS VRPEDESOPERSERV,
                                'PADRAO' AS ORIGEM, TS.IDSERVOBRIGPROS
                    FROM TIPOSERV TS, PROPOSTAFAS PR, PROPOSTASERV PS, OPERTIPOSERV OP
                            WHERE PS.NRPROPOSFAS  = :NRPROPOSFAS
                              AND PS.NRVERPROPFAS = :NRVERPROPFAS
                              AND TS.CDTIPOSERV = PS.CDTIPOSERV
                              AND PR.NRPROPOSFAS = PS.NRPROPOSFAS
                              AND PR.NRVERPROPFAS = PS.NRVERPROPFAS
                              AND OP.CDTIPOSERV(+) = TS.CDTIPOSERV
                              AND OP.CDOPERADOR(+) = :CDOPERADOR) PSV
                    WHERE ENP.CDPROSPECT = :CDCLIEPROS
                      AND ENP.IDTPENDEPROS = 'P'
                      AND TPS.CDTIPOSERV = PSV.CDTIPOSERV(+)
                      AND (TPS.IDPROPSERVWEB = 'S' OR PSV.NRSERVPROP IS NOT NULL)
                    ORDER BY TPS.NMTIPOSERV, NVL(PSV.DSLOCALPROP, '')";
                
        $params = array(
            'NRORG'        => $nrorg, 
            'NRPROPOSFAS'  => $nrproposfas, 
            'NRVERPROPFAS' => $nrverpropfas,
            'CDOPERADOR'   => $cdoperador,
            'CDCLIEPROS'   => $cdcliepros
        );
                
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function consultaValorTotalServicos($nrproposfas, $nrverpropfas)
    {
        $sql = "SELECT NVL(SUM(VRDEHORAPROP*QTSERVPROP),0) AS VRSERVICO
                                FROM PROPOSTASERV
                               WHERE NRPROPOSFAS  = :NRPROPOSFAS
                                 AND NRVERPROPFAS = :NRVERPROPFAS";
        
        $params = array( 
            'NRPROPOSFAS'  => $nrproposfas, 
            'NRVERPROPFAS' => $nrverpropfas        
        );
        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    public static function consultaParcelasNegociarServicos($nrproposfas, $nrverpropfas)
    {
        $sql = "SELECT VC.DTVENCSERVPROP, VC.NRPROPOSFAS, VC.NRVERPROPFAS, 
                       VC.VRVENCSERVPROP, ROWNUM AS NRPARCELA
                FROM (SELECT DTVENCSERVPROP, 
                       NRPROPOSFAS, NRVERPROPFAS, VRVENCSERVPROP
                FROM VENCSERVPROP
               WHERE NRPROPOSFAS = :NRPROPOSFAS
                 AND NRVERPROPFAS = :NRVERPROPFAS
               ORDER BY DTVENCSERVPROP) VC
               ORDER BY VC.DTVENCSERVPROP";
        
        $params = array( 
            'NRPROPOSFAS'  => $nrproposfas, 
            'NRVERPROPFAS' => $nrverpropfas        
        );
        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }               
}