/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_INSUMETAPA                                               */
/* Tabela : INSUMETAPA		                                                */
/*                                                                            */
/* Criao:                                                                   */
/* 05/08/2005 - JOAO PAULO REIS                                               */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_INSUMETAPA
BEFORE INSERT OR UPDATE OR DELETE
ON INSUMETAPA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUIETA := SYSDATE;
   END IF;
   IF UPDATING THEN
      if (NVL(:OLD.CDPRODUTO   ,0) <> NVL(:NEW.CDPRODUTO   ,0)) OR
         (NVL(:OLD.CDPRODINSUMO,0) <> NVL(:NEW.CDPRODINSUMO,0)) OR
         (NVL(:OLD.CDPROCFABRIC,0) <> NVL(:NEW.CDPROCFABRIC,0)) OR
         (NVL(:OLD.IDSEMIACETAP,0) <> NVL(:NEW.IDSEMIACETAP,0)) OR
         (NVL(:OLD.CDETAPAPROD ,0) <> NVL(:NEW.CDETAPAPROD ,0)) OR
         (NVL(:OLD.CDFILIAL    ,0) <> NVL(:NEW.CDFILIAL    ,0)) OR
         (NVL(:OLD.IDUTAPRREQET,0) <> NVL(:NEW.IDUTAPRREQET,0)) OR
         (NVL(:OLD.IDLOTEPRETAP,0) <> NVL(:NEW.IDLOTEPRETAP,0)) OR
         (NVL(:OLD.VRFATOPADR,0)   <> NVL(:NEW.VRFATOPADR,0)) THEN
         :NEW.DTULTATUIETA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('INSUMETAPA', '',  'CDPRODUTO    ='||:OLD.CDPRODUTO   ||';
                                                   CDPROCFABRIC ='||:OLD.CDPROCFABRIC||';
								   CDETAPAPROD  ='||:OLD.CDETAPAPROD ||';
                                                   CDPRODINSUMO ='||:OLD.CDPRODINSUMO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE INSUMETAPA MODIFY DTULTATUIETA DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_INSUMETAPA','4.05.081'); END;
/

