package com.javaseleniumtemplate.pages;


import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class ExclusaoPage extends PageBase {

    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By msgConfirmaTela = By.xpath("//div[@class = 'navbar-brand zh-header-title has-header-info']");
    By botaoInicial = By.xpath("//*[@type = 'button']");
    By displayInicio = By.xpath("//*[@type = 'button']");
    By clicarBotao = By.xpath("//*[@class = 'menu-link'] //*[contains(text(),'Parametrização')]");

    By clicaPlanejamento = By.xpath("//ul[@class = 'sub-menu']//*[contains(text(),'Planejamento')]");

    By clicaEmPrato = By.xpath("//ul[@class = 'sub-menu']//li[@class = 'menu-item closed sub-menu-item has-child visible']//span[@class = 'menu-link']//*[contains(text(),'Prato')]");
    By clicaGrupoTipoPrato = By.xpath("//ul[@class = 'sub-menu']//li[@ng-repeat='menu in _menu.menus']//span[@class = 'menu-link']//*[contains(text(),'Grupo de Tipo de Prato')]");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");


    //Actions
    public String retornaUsernameDasInformacoesDeLogin() {
        return getText(usernameLoginInfoTextArea);
    }

    public String retornaMensagemTela() {
        return getText(msgConfirmaTela);

    }

    public void clicarEmMenuPrincipal() {

        waitForElement(displayInicio);
        waitForElement(usernameLoginInfoTextArea);
        click(botaoInicial);
    }

    public void clicarEmPParametrizacao() {

        // waitForElement(displayInicio);
          waitForElement(usernameLoginInfoTextArea);
         click(clicarBotao);


    }

    public void clicarEmPlanejamento() {
        //  waitForElement(btnMedicao);
        click(clicaPlanejamento);
    }

    public void clicarEmPrato() {
        waitForVisibilityOfElementLocated(clicaEmPrato);
        click(clicaEmPrato);
    }

    public void clicarGrupoTipodePrato() {
        waitForVisibilityOfElementLocated(clicaGrupoTipoPrato);
        click(clicaGrupoTipoPrato);
    }
}




